CREATE TABLE SEMINAREMAILS
(
  SEM_KEY NUMBER NOT NULL
, SEM_SEP_SEMINAR VARCHAR2(50) NOT NULL
, SEM_MVT_BEREICH VARCHAR2(100) NOT NULL
, SEM_ANHAENGE VARCHAR2(4000)
, SEM_ABSENDER VARCHAR2(4000) NOT NULL
, SEM_EMPFAENGER VARCHAR2(4000) NOT NULL
, SEM_EMPFAENGERCC VARCHAR2(4000)
, SEM_EMPFAENGER_BCC VARCHAR2(4000)
, SEM_USER VARCHAR2(50)
, SEM_USERDAT DATE DEFAULT sysdate
, CONSTRAINT SEMINAREMAILS_PK PRIMARY KEY
  (
    SEM_SEP_SEMINAR
  , SEM_MVT_BEREICH
  )
  USING INDEX
  (
      CREATE UNIQUE INDEX UID_SEM_SEMINAR_MVT_BEREICH ON SEMINAREMAILS (SEM_SEP_SEMINAR ASC, SEM_MVT_BEREICH ASC)
      TABLESPACE INDX
  )
  ENABLE
);

CREATE INDEX IDX_SEM_MVT_BEREICH ON SEMINAREMAILS (SEM_MVT_BEREICH)
TABLESPACE INDX;

CREATE UNIQUE INDEX IDX_SEM_SEMINAR ON SEMINAREMAILS (SEM_KEY)
TABLESPACE INDX;

COMMENT ON COLUMN SEMINAREMAILS.SEM_SEP_SEMINAR IS 'SEMINARNUMMER';

COMMENT ON COLUMN SEMINAREMAILS.SEM_MVT_BEREICH IS 'Mailversandtext bereich';

COMMENT ON COLUMN SEMINAREMAILS.SEM_ANHAENGE IS 'Unserialized Array mit Anhängen';

COMMENT ON COLUMN SEMINAREMAILS.SEM_ABSENDER IS 'Absender in Klartext';

COMMENT ON COLUMN SEMINAREMAILS.SEM_EMPFAENGER IS 'Unserialized Array mit Empfänger';

COMMENT ON COLUMN SEMINAREMAILS.SEM_EMPFAENGERCC IS 'Unserialized Array mit EmpfängerCC';

COMMENT ON COLUMN SEMINAREMAILS.SEM_EMPFAENGER_BCC IS 'Unserialized Array mit EmpfängerBCC';

CREATE SEQUENCE SEQ_SEM_KEY;

CREATE TRIGGER TRG_SEQ_SEM_KEY
BEFORE INSERT ON SEMINAREMAILS
FOR EACH ROW
BEGIN
  <<COLUMN_SEQUENCES>>
  BEGIN
    IF INSERTING AND :NEW.SEM_KEY IS NULL THEN
      SELECT SEQ_SEM_KEY.NEXTVAL INTO :NEW.SEM_KEY FROM SYS.DUAL;
    END IF;
  END COLUMN_SEQUENCES;
END;
/
